<template>
  <div
    class="flex flex-col justify-between overflow-hidden rounded-lg vertical-promotion-card"
  >
    <div
      :class="{ 'image-border-theme': theme, 'image-border': !theme }"
      class="w-full image-border"
    >
      <div class="w-full h-full aspect-[560/240]">
        <img
          v-lazy="promotion.ImagePathForDisplay"
          class="object-contain w-full h-full"
          @error="handleError"
        />
      </div>
      <span v-if="theme" class="line-relative">
        <hr class="line-style" />
      </span>
    </div>
    <el-scrollbar>
      <div class="promotion-content">
        <div
          :class="{ 'text-xs': theme, 'text-base': !theme }"
          class="promotion-date-range"
        >
          {{ promotion.DateRangeForDisplay }}
        </div>
        <div class="promotion-title">
          {{ promotion.Title }} ({{ promotion.PromoCode }})
        </div>
        <div class="promotion-remark" v-html="promotion.Remark"></div>
      </div>
    </el-scrollbar>
    <div class="flex justify-center gap-[16px] p-4 pt-2">
      <el-button
        plain
        round
        class="more-info promotion-button uppercase"
        @click="onMoreInfo"
        :id="`${ID.PROMOTION_INFO}_${ID.PROMOTION_TYPE_ID[promotion.PromotionTypeId]}_${promotion.Id}`"
      >
        {{ $t("more_info") }}
      </el-button>
      <el-button
        v-if="buttonApplyPromotionEnabled(promotion)"
        type="primary"
        class="apply promotion-button"
        round
        :disabled="isProcessing"
        @click="onApplyPromotion(promotion)"
        :id="`${ID.PROMOTION_APPLY}_${ID.PROMOTION_TYPE_ID[promotion.PromotionTypeId]}_${promotion.Id}`" >
        {{ $t("apply") }}
      </el-button>
      <nuxt-link v-if="!authenticated" to="/login">
        <el-button type="primary" class="apply promotion-button" round
        :id="`${ID.PROMOTION_APPLY}_${ID.PROMOTION_TYPE_ID[promotion.PromotionTypeId]}_${promotion.Id}`" >    
          {{ $t("apply") }}
        </el-button>
      </nuxt-link>
    </div>
  </div>
  <el-dialog
    v-model="isDialogVisible"
    top="5vh"
    custom-class="custom-dialog"
    :show-close="false"
    destroy-on-close
  >
    <div class="relative custom-header">
      {{ promotion.Title }}
      <div class="absolute right-7 top-4">
        <font-awesome-icon
          class="text-[25px] cursor-pointer close-icon"
          icon="xmark"
          @click="onClose"
        />
      </div>
    </div>
    <div class="custom-content px-[40px] pt-[40px]">
      <div class="flex dialog-border-bottom pb-[20px] gap-[20px]">
        <div
          class="w-[var(--promotion-dialog-image-width)] h-[var(--promotion-dialog-image-height)] rounded-lg overflow-hidden"
        >
          <img
            v-lazy="promotion.ImagePathForDisplay"
            class="object-contain w-full h-full"
            @error="handleError"
          />
        </div>
        <div class="flex flex-col w-[320px]">
          <div class="promotion-dialog-date-range fc-primary">
            {{ promotion.DateRangeForDisplay }}
          </div>
          <div class="promotion-dialog-title">
            {{ promotion.Title }} ({{ promotion.PromoCode }})
          </div>
          <div class="promotion-dialog-remark" v-html="promotion.Remark"></div>
        </div>
      </div>
    </div>
    <div class="pt-[20px] px-[40px]">
      <el-scrollbar max-height="300px">
        <div class="promotion-content" v-html="promotion.Content"></div>
      </el-scrollbar>
    </div>
    <div class="flex pt-[40px] pb-[28px] justify-center gap-[16px]">
      <el-button
        plain
        round
        class="close-promotion-dialog"
        @click="onClose"
      >
        {{ $t("close") }}
      </el-button>
      <nuxt-link v-if="!authenticated" to="/login">
        <el-button type="primary" class="apply promotion-button" round
        :id="`${ID.PROMOTION_APPLY}_${ID.PROMOTION_TYPE_ID[promotion.PromotionTypeId]}_${promotion.Id}`" >
          {{ $t("apply") }}
        </el-button>
      </nuxt-link>
      <el-button
        v-if="buttonApplyPromotionEnabled(promotion)"
        type="primary"
        class="apply promotion-button"
        round
        :loading="isProcessing"
        @click="onApplyPromotion(promotion)"
        :id="`${ID.PROMOTION_APPLY}_${ID.PROMOTION_TYPE_ID[promotion.PromotionTypeId]}_${promotion.Id}`" >
        {{ $t("apply") }}
      </el-button>
    </div>
  </el-dialog>
</template>
<script lang="ts">
import { IPromotion } from "@/models/promotion/promotion";
import { defineComponent, PropType, ref } from "vue";
import { ID } from "~~/utils/constants";

export default defineComponent({
  name: "VerticalPromotionCard",
  props: {
    promotion: {
      type: Object as PropType<IPromotion>,
      required: true,
    },
    authenticated: {
      type: Boolean,
      default: false,
    },
    onApplyPromotion: {
      type: Function,
      required: true,
    },
    isProcessing: {
      type: Boolean,
      default: false,
    },
    buttonApplyPromotionEnabled: {
      type: Function,
      required: true,
    },
    theme: {
      type: Boolean,
      required: false,
    },
  },
  setup() {
    const isDialogVisible = ref(false);
    const onMoreInfo = () => {
      isDialogVisible.value = true;
    };
    const onClose = () => {
      isDialogVisible.value = false;
    };
    const handleError = () => {
      // console.error("error");
    };
    return {
      isDialogVisible,
      onMoreInfo,
      handleError,
      onClose,
    };
  },
});
</script>
<style lang="scss">
:root {
  --promotion-card-height: 380px;
  --promotion-card-width: 392px;
  --promotion-image-border-color: var(--hint);
  --promotion-card-background: var(--background-card);
  --promotion-more-info-button-color: var(--primary);
  --promotion-more-info-active-button-color: var(--text);
  --promotion-apply-button-color: var(--primary);
  --promotion-apply-button-text-color: var(--text2);
  --promotion-close-button-color: var(--failure);
  --promotion-font-color: var(--text);
  --promotion-button-width: 172px;
  --promotion-date-range-color: var(--primary);
  --promotion-title-color: var(--text5);
  --promotion-remark-color: var(--text);
  --promotion-dialog-background: var(--background2);
  --promotion-dialog-header-background: var(--background1);
  --promotion-dialog-image-width: 392px;
  --promotion-dialog-image-height: 168px;
  --promotion-dialog-width: 812px;
  --promotion-dialog-content-color: var(--text2);
  --promotion-dialog-close-icon: var(--border);
  --promotion-dialog-border-button: var(--primary);
}
.close-icon {
  color: var(--promotion-font-color);
}
.vertical-promotion-card {
  min-height: var(--promotion-card-height);
  height: 100%;
  background-color: var(--promotion-card-background);

  .image-border {
    border-bottom: 2px solid var(--primary);
  }
  .image-border-theme {
    border-bottom: 6px solid var(--primary);
  }
  .promotion-date-range {
    padding: 23.7px 16px 0px 16px;
    color: var(--primary);
    font-weight: 400;
    letter-spacing: 0.02em;
  }
  .promotion-title {
    padding: 8px 16px 0px 16px;
    color: var(--text5);
    font-weight: 700;
    font-size: 20px;
    line-height: 23px;
    letter-spacing: 0.02em;
  }
  .promotion-remark {
    padding: 8px 16px 0px 16px;
    font-size: 14px;
    line-height: 20px;
    letter-spacing: 0.02em;
    color: var(--text5);
    word-break: break-word;
  }
}
.promotion-button {
  width: var(--promotion-button-width);
  border-radius: var(--el-border-radius-round);
  color: var(--primary);
  font-weight: 700;
  font-size: 14px;
  border: 1px solid var(--primary);
  span {
    font-weight: 700;
  }
}
.close.el-button.el-button--primary.is-plain {
  --el-button-text-color: var(--text5);
  --el-button-border-color: var(--text5);
  --el-button-hover-bg-color: var(--promotion-more-info-active-button-color);
  --el-button-hover-border-color: var(
    --promotion-more-info-active-button-color
  );
  --el-button-active-border-color: var(
    --promotion-more-info-active-button-color
  );
  --el-button-hover-text-color: var(--promotion-close-button-color);
  --el-button-active-text-color: var(--promotion-close-button-color);
}
.more-info.el-button.el-button--primary.is-plain {
  --el-button-text-color: var(--promotion-more-info-button-color);
  --el-button-border-color: var(--promotion-more-info-button-color);
  --el-button-hover-bg-color: var(--promotion-more-info-active-button-color);
  --el-button-hover-border-color: var(
    --promotion-more-info-active-button-color
  );
  --el-button-active-border-color: var(
    --promotion-more-info-active-button-color
  );
  --el-button-hover-text-color: var(--promotion-more-info-button-color);
  --el-button-active-text-color: var(--promotion-more-info-button-color);
}
.apply.el-button.el-button--primary {
  --primary: var(--promotion-more-info-button-color);
  --el-button-text-color: var(--promotion-apply-button-text-color);
}
.promotion-dialog-date-range {
  padding: 0px;
  color: var(--promotion-date-range-color);
  font-size: 16px;
  font-weight: 400;
  letter-spacing: 0.02em;
}
.promotion-dialog-title {
  padding: 8px 0px 0px 0px;
  color: var(--promotion-title-color);
  font-weight: 700;
  font-size: 20px;
  line-height: 23px;
  letter-spacing: 0.02em;
}
.promotion-dialog-remark {
  padding: 8px 0px 0px 0px;
  font-size: 14px;
  line-height: 20px;
  letter-spacing: 0.02em;
  color: var(--text5);
}
.el-overlay-dialog:has(.custom-dialog.el-dialog) {
  display: flex;
}
.custom-dialog.el-dialog {
  --el-dialog-width: var(--promotion-dialog-width);
  border-radius: 15px;
  overflow: hidden;
  margin: auto;
}
.custom-dialog {
  .el-dialog__header {
    padding: 0;
  }
  .el-dialog__body {
    padding: 0;
    background: var(--promotion-dialog-background);

    .dialog-border-bottom {
      border-bottom: 1px solid var(--promotion-dialog-border-button);
    }
  }
  .el-scrollbar {
    max-height: 300px;
    height: auto;

    .el-scrollbar__wrap {
      height: auto;
    }
  }
}
.custom-header {
  display: flex;
  justify-content: center;
  align-items: center;
  padding: 12px 0px;
  font-size: 20px;
  font-weight: 700;
  color: white;
  background: var(--primary);
}
.line-relative {
  position: relative;
  bottom: 5px;
}
.line-style {
  height: 9px;
  background-color: var(--primary);
  margin: 0 130px;
  border-color: var(--primary);
  border-radius: 5px;
  border-width: 5px;
}
.promotion-close-button {
  background: #fff;
  width: 30px;
  display: flex;
  text-align: center;
  justify-content: center;
  height: 30px;
  border-radius: 50%;
  right: 0.75rem;
  top: 0.75rem;
}
.promotion-close-button svg {
  height: auto;
  color: var(--primary);
}
.close-promotion-dialog {
  color: var(--primary);
  border: 1px solid var(--primary);
  width: var(--promotion-button-width);
}
</style>
